<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <s:div id="globalDiv">
                <h1>#{messages['gazelle.HL7Common.SimulatorManager']}</h1>
                <s:div id="configListDiv">
                    <s:decorate template="/layout/panels/_panel_title_footer_id.xhtml"
                                rendered="#{simulatorResponderConfigurationManager.listConfig}">
                        <ui:param name="panel_id" value="configList"/>
                        <ui:define name="panel_title">#{messages['gazelle.hl7.HL7V2xServers']}</ui:define>
                        <rich:dataTable value="#{simulatorResponderConfigurationManager.listAllConfigurations()}"
                                        var="conf"
                                        id="hl7resptable"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="ds">
                            <g:column id="nameColumn" sortBy="#{conf.name}" filterBy="#{'name'}"
                                      filterEvent="keyup">
                                <ui:define name="header">#{messages['gazelle.HL7Common.Name']}</ui:define>
                                #{conf.name}
                            </g:column>
                            <g:column id="simulatedActorColumn" filterBy="#{'simulatedActor.name'}"
                                      filterEvent="keyup">
                                <ui:define name="header">#{messages['gazelle.HL7Common.simulatedActor']}</ui:define>
                                <h:outputText value="#{conf.simulatedActor.name}"/>
                                <h:outputText value=" (#{conf.domain.keyword})"
                                              rendered="#{conf.domain != null}"/>
                            </g:column>
                            <g:column id="transactionColumn" filterBy="#{'transaction.keyword'}"
                                      filterEvent="keyup">
                                <ui:define name="header">#{messages['gazelle.HL7Common.Transaction']}</ui:define>
                                <h:outputText value="#{conf.transaction.keyword}"
                                              rendered="#{conf.transaction != null}"/>
                                <h:outputText value="#{messages['gazelle.HL7Common.All']}"
                                              rendered="#{conf.transaction == null}"/>
                            </g:column>
                            <g:column id="endpointColumn">
                                <ui:define name="header">#{messages['gazelle.HL7Common.Endpoint']}</ui:define>
                                <h:outputText value="#{conf.ipAddress}:#{conf.listeningPort}"
                                    rendered="#{conf.hl7Protocol == 'MLLP'}"/>
                                <h:outputText value="#{conf.url}"
                                              rendered="#{conf.hl7Protocol == 'HTTP'}"/>
                            </g:column>
                            <g:column id="status">
                                <ui:define name="header">#{messages['gazelle.hl7.Status']}</ui:define>
                                <h:outputText value="#{messages['gazelle.hl7.Running']}" rendered="#{conf.running}"
                                              styleClass="gzl-label gzl-label-green"/>
                                <h:outputText value="#{messages['gazelle.hl7.Stopped']}" rendered="#{not conf.running}"
                                              styleClass="gzl-label gzl-label-red"/>
                            </g:column>
                            <g:column id="actions">
                                <ui:define name="header">#{messages['gazelle.HL7Common.Action']}</ui:define>
                                <div class="gzl-never-wrap">
                                    <a4j:commandLink
                                            actionListener="#{simulatorResponderConfigurationManager.displayConfiguration(conf)}"
                                            execute="@this"
                                            render="globalDiv">
                                        <s:span styleClass="gzl-icon-search "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink
                                            actionListener="#{simulatorResponderConfigurationManager.editConfiguration(conf)}"
                                            execute="@this"
                                            render="globalDiv">
                                        <s:span styleClass="gzl-icon-pencil "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink
                                            actionListener="#{simulatorResponderConfigurationManager.copyConfiguration(conf)}"
                                            execute="@this"
                                            render="globalDiv">
                                        <span class="gzl-icon-clone"/>
                                    </a4j:commandLink>
                                    <a4j:commandLink
                                            actionListener="#{simulatorResponderConfigurationManager.startResponder(conf)}"
                                            execute="@this" rendered="#{conf.hl7Protocol == 'MLLP' and not conf.running}"
                                            render="configList">
                                        <s:span styleClass="gzl-icon-play "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink
                                            actionListener="#{simulatorResponderConfigurationManager.stopResponder(conf)}"
                                            render="configList" rendered="#{conf.hl7Protocol == 'MLLP' and conf.running}">
                                        <s:span styleClass="gzl-icon-stop "/>
                                    </a4j:commandLink>
                                </div>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="hl7resptable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['gazelle.HL7Common.CreateNewConfiguration']}"
                                               actionListener="#{simulatorResponderConfigurationManager.createNewConfiguration()}"
                                               render="globalDiv" styleClass="gzl-btn-green"/>
                            <a4j:commandButton
                                    value="#{messages['net.ihe.gazelle.simulator.hl7.StopAllRunningServers']}"
                                    oncomplete="jq162('#confirmStop').modal('show');" styleClass="gzl-btn-red"
                                    render="confirmStopContent"/>
                            <a4j:commandButton
                                    value="#{messages['net.ihe.gazelle.simulator.hl7.StartAllStoppedServers']}"
                                    oncomplete="jq162('#confirmStart').modal('show');"
                                    styleClass="gzl-btn-green" render="confirmStartContent"/>
                        </ui:define>
                    </s:decorate>
                </s:div>
                <ui:include src="/administration/displayHL7Responder.xhtml"/>
                <ui:include src="/administration/editHL7Responder.xhtml"/>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="confirmStart"/>
                    <ui:define name="popup_title">
                        <span class="gzl-icon-exclamation-triangle"/>
                        #{messages['net.ihe.gazelle.simulator.hl7.ConfirmationBox']}
                    </ui:define>
                    <ui:param name="styleClass" value="modal-sm"/>
                    <ui:param name="headerStyleClass" value="gzl-text-red"/>
                    <ui:param name="bodyStyleClass" value="bg-warning"/>
                    <s:div id="confirmStartContent">
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.simulator.hl7.YouAreAboutToStartAllTheHL7ServersWhichAreCurren']}"/>
                    </s:div>
                    <ui:define name="popup_footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.simulator.hl7.Yes']}"
                                           actionListener="#{simulatorResponderStartStop.startAllServers()}"
                                           oncomplete="jq162('#confirmStart').modal('hide');"
                                           render="configListDiv"
                                           styleClass="gzl-btn-green"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.simulator.hl7.No']}"
                                           onclick="jq162('#confirmStart').modal('hide');"
                                           styleClass="gzl-btn" render="configListDiv"/>
                    </ui:define>
                </ui:decorate>
                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="confirmStop"/>
                    <ui:define name="popup_title">
                        <span class="gzl-icon-exclamation-triangle"/>
                        #{messages['net.ihe.gazelle.simulator.hl7.ConfirmationBox']}
                    </ui:define>
                    <ui:param name="styleClass" value="modal-sm"/>
                    <ui:param name="headerStyleClass" value="gzl-text-red"/>
                    <ui:param name="bodyStyleClass" value="bg-warning"/>
                    <s:div id="confirmStopContent">
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.simulator.hl7.YouAreAboutToStopAllTheRunningHL7ServersDoYouRea']}"/>
                    </s:div>
                    <ui:define name="popup_footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.simulator.hl7.Yes']}"
                                           actionListener="#{simulatorResponderStartStop.stopAllServers()}"
                                           oncomplete="jq162('#confirmStop').modal('hide');"
                                           render="configListDiv" styleClass="gzl-btn-green"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.simulator.hl7.No']}"
                                           onclick="jq162('#confirmStop').modal('hide');"
                                           styleClass="gzl-btn" render="configListDiv"/>
                    </ui:define>
                </ui:decorate>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
